#include "ABACUS.h"
using namespace std;

DP ABACUS::lndet_LU (SQMat_DP a)
{
  // Returns the ln of abs of determinant of matrix a, through LU decomposition

  Vect_INT indx(a.size());

  SQMat_DP mat = a;

  DP d;

  ABACUS::ludcmp (mat, indx, d);

  DP logdet = log(DP(d));
  for (int j = 0; j < mat.size(); j++) {
    logdet += log(fabs(mat[j][j]));
  }

  return(logdet);
}
